    PROGRAM g01fbfe

!      G01FBF Example Program Text

!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : g01fbf, nag_wp
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       REAL (KIND=nag_wp)              :: df, p, x
       INTEGER                         :: ifail
       CHARACTER (1)                   :: tail
!      .. Executable Statements ..
       WRITE (nout,*) 'G01FBF Example Program Results'
       WRITE (nout,*)

!      Skip heading in data file
       READ (nin,*)

!      Display titles
       WRITE (nout,*) '     P      DF    TAIL      X'
       WRITE (nout,*)

D_LP:  DO
          READ (nin,*,IOSTAT=ifail) p, df, tail
          IF (ifail/=0) THEN
             EXIT D_LP
          END IF

!         Calculate deviates (inverse CDF)
          ifail = -1
          x = g01fbf(tail,p,df,ifail)
          IF (ifail/=0) THEN
             IF (ifail/=4 .AND. ifail/=5) THEN
                EXIT D_LP
             END IF
          END IF

!         Display results 
          WRITE (nout,99999) p, df, tail, x
       END DO D_LP

99999  FORMAT (1X,2F8.3,3X,A1,3X,F8.3,A,I1)
    END PROGRAM g01fbfe
